---
title: RegExpInstance.lastIndex
slug: Web/JavaScript/Reference/Global_Objects/RegExp/lastIndex
tags:
  - JavaScript
  - Property
  - Reference
  - RegExp
  - Regular Expressions
---
<div>{{JSRef}}</div>

<p>The <strong><code>lastIndex</code></strong> is a read/write integer property of regular expression instances that specifies the index at which to start the next match.</p>

<div>{{EmbedInteractiveExample("pages/js/regexp-lastindex.html")}}</div>

<div>{{js_property_attributes(1, 0, 0)}}</div>

<h2 id="Description">Description</h2>

<p>This property is set only if the regular expression instance used the <code>g</code> flag to indicate a global search, or the <code>y</code> flag to indicate a sticky search. The following rules apply:</p>

<ul>
 <li>If <code>lastIndex</code> is greater than the length of the string, {{jsxref("RegExp.prototype.test()", "test()")}} and {{jsxref("RegExp.prototype.exec()", "exec()")}} fail, then <code>lastIndex</code> is set to 0.</li>
 <li>If <code>lastIndex</code> is equal to or less than the length of the string and if the regular expression matches the empty string, then the regular expression matches input starting from <code>lastIndex</code>.</li>
 <li>If <code>lastIndex</code> is equal to the length of the string and if the regular expression does not match the empty string, then the regular expression mismatches input, and <code>lastIndex</code> is reset to 0.</li>
 <li>Otherwise, <code>lastIndex</code> is set to the next position following the most recent match.</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Using_lastIndex">Using lastIndex</h3>

<p>Consider the following sequence of statements:</p>

<pre class="brush: js notranslate">var re = /(hi)?/g;
</pre>

<p>Matches the empty string.</p>

<pre class="brush: js notranslate">console.log(re.exec('hi'));
console.log(re.lastIndex);
</pre>

<p>Returns <code>["hi", "hi"]</code> with <code>lastIndex</code> equal to 2.</p>

<pre class="brush: js notranslate">console.log(re.exec('hi'));
console.log(re.lastIndex);
</pre>

<p>Returns <code>["", undefined]</code>, an empty array whose zeroth element is the match string. In this case, the empty string because <code>lastIndex</code> was 2 (and still is 2) and <code>hi</code> has length 2.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-properties-of-regexp-instances', 'RegExp.lastIndex')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.RegExp.lastIndex")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("RegExp.prototype.ignoreCase")}}</li>
 <li>{{jsxref("RegExp.prototype.global")}}</li>
 <li>{{jsxref("RegExp.prototype.multiline")}}</li>
 <li>{{jsxref("RegExp.prototype.source")}}</li>
 <li>{{jsxref("RegExp.prototype.sticky")}}</li>
</ul>
